SoVRMLCollision(3)

NAME
SoVRMLCollision - The SoVRMLCollision class is used for collision detection with the avatar.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLCollision.h>

Inherits SoVRMLGroup.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLCollision (void)
SoVRMLCollision (int numchildren)
virtual void GLRender (SoGLRenderAction *action)
virtual void notify (SoNotList *list)
Public Member Functions inherited from SoVRMLGroup
SoVRMLGroup (void)
SoVRMLGroup (int numChildren)
virtual void doAction (SoAction *action)
virtual void callback (SoCallbackAction *action)
virtual void getBoundingBox (SoGetBoundingBoxAction *action)
virtual void getMatrix (SoGetMatrixAction *action)
virtual void rayPick (SoRayPickAction *action)
virtual void search (SoSearchAction *action)
virtual void write (SoWriteAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void audioRender (SoAudioRenderAction *action)
virtual void GLRenderBelowPath (SoGLRenderAction *action)
virtual void GLRenderInPath (SoGLRenderAction *action)
virtual void GLRenderOffPath (SoGLRenderAction *action)
Public Member Functions inherited from SoVRMLParent
virtual SbBool affectsState (void) const
virtual void addChild (SoNode *child)
virtual void insertChild (SoNode *child, int idx)
virtual SoNode * getChild (int idx) const
virtual int findChild (const SoNode *child) const
virtual int getNumChildren (void) const
virtual void removeChild (int idx)
virtual void removeChild (SoNode *child)
virtual void removeAllChildren (void)
virtual void replaceChild (int idx, SoNode *child)
virtual void replaceChild (SoNode *old, SoNode *child)
virtual SoChildList * getChildren (void) const
Public Member Functions inherited from SoGroup
SoGroup (void)
SoGroup (int nchildren)
virtual void handleEvent (SoHandleEventAction *action)
virtual void pick (SoPickAction *action)
virtual void addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
Public Member Functions inherited from SoNode
void setOverride (const SbBool state)
SbBool isOverride (void) const
void setNodeType (const NodeType type)
NodeType getNodeType (void) const
virtual SoNode * copy (SbBool copyconnections=FALSE) const
virtual void grabEventsSetup (void)
virtual void grabEventsCleanup (void)
virtual void startNotify (void)
SbUniqueId getNodeId (void) const
virtual void writeInstance (SoOutput *out)
virtual SoNode * addToCopyDict (void) const
virtual SoFieldContainer * copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void setToDefaults (void)
SbBool hasDefaultValues (void) const
SbBool fieldsAreEqual (const SoFieldContainer *container) const
void copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool set (const char *const fielddata)
void get (SbString &fielddata)
virtual int getFields (SoFieldList &l) const
virtual int getAllFields (SoFieldList &l) const
virtual SoField * getField (const SbName &name) const
virtual SoField * getEventIn (const SbName &name) const
virtual SoField * getEventOut (const SbName &name) const
SbBool getFieldName (const SoField *const field, SbName &name) const
SbBool enableNotify (const SbBool flag)
SbBool isNotifyEnabled (void) const
SbBool set (const char *fielddata, SoInput *input)
void get (SbString &fielddata, SoOutput *out)
virtual SbBool validateNewFieldValue (SoField *field, void *newval)
SbBool getIsBuiltIn (void) const
virtual void getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void setUserData (void *userdata) const
void * getUserData (void) const
Public Member Functions inherited from SoBase
void ref (void) const
void unref (void) const
void unrefNoDelete (void) const
int32_t getRefCount (void) const
void touch (void)
SbBool isOfType (SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
virtual SbName getName (void) const
virtual void setName (const SbName &newname)
void addAuditor (void *const auditor, const SoNotRec::Type type)
void removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & getAuditors (void) const
SbBool shouldWrite (void)
void assertAlive (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Static Public Member Functions inherited from SoVRMLGroup
static SoType getClassTypeId (void)
static void initClass (void)
static void setNumRenderCaches (int num)
static int getNumRenderCaches (void)
Static Public Member Functions inherited from SoVRMLParent
static SoType getClassTypeId (void)
static void initClass (void)
static void updateChildList (const SoNode *const *nodes, const int numnodes, SoChildList &cl)
static void updateChildList (SoNode *nodewithsfnode, SoChildList &cl)
Static Public Member Functions inherited from SoGroup
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t getCompatibilityTypes (const SoType &nodetype)
static SoType getClassTypeId (void)
static SoNode * getByName (const SbName &name)
static int getByName (const SbName &name, SoNodeList &l)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SbUniqueId getNextNodeId (void)
static int getActionMethodIndex (const SoType type)
static void getBoundingBoxS (SoAction *action, SoNode *node)
static void GLRenderS (SoAction *action, SoNode *node)
static void callbackS (SoAction *action, SoNode *node)
static void getMatrixS (SoAction *action, SoNode *node)
static void handleEventS (SoAction *action, SoNode *node)
static void pickS (SoAction *action, SoNode *node)
static void rayPickS (SoAction *action, SoNode *node)
static void searchS (SoAction *action, SoNode *node)
static void writeS (SoAction *action, SoNode *node)
static void audioRenderS (SoAction *action, SoNode *node)
static void getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void cleanupClass (void)
static void initCopyDict (void)
static void addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void copyDone (void)
Static Public Member Functions inherited from SoBase
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static void addName (SoBase *const base, const char *const name)
static void removeName (SoBase *const base, const char *const name)
static void incrementCurrentWriteCounter (void)
static void decrementCurrentWriteCounter (void)
static SoBase * getNamedBase (const SbName &name, SoType type)
static int getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool read (SoInput *input, SoBase *&base, SoType expectedtype)
static void setInstancePrefix (const SbString &c)
static void setTraceRefs (SbBool trace)
static SbBool getTraceRefs (void)
static SbBool connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool readRoute (SoInput *input)

  Public Attributes
SoSFBool collide
SoSFNode proxy
SoSFTime collideTime
Public Attributes inherited from SoVRMLGroup
SoSFEnum renderCaching
SoSFEnum boundingBoxCaching
SoSFEnum renderCulling
SoSFEnum pickCulling
SoSFVec3f bboxCenter
SoSFVec3f bboxSize
Public Attributes inherited from SoVRMLParent
SoMFNode children

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoVRMLCollision ()
Protected Member Functions inherited from SoVRMLGroup
virtual ~SoVRMLGroup ()
virtual SbBool cullTest (SoState *state)
Protected Member Functions inherited from SoVRMLParent
SoVRMLParent (void)
SoVRMLParent (int approxchildren)
virtual ~SoVRMLParent ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)
virtual void copyContents (const SoFieldContainer *from, SbBool copyConn)
Protected Member Functions inherited from SoGroup
virtual ~SoGroup ()
virtual SbBool readChildren (SoInput *in)
virtual SoNotRec createNotRec (void)
void setOperation (const SoNotRec::OperationType opType=SoNotRec::UNSPECIFIED, const SoNode *cc=NULL, const SoNode *pc=NULL, const int ci=-1)
Protected Member Functions inherited from SoNode
SoNode (void)
virtual ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
SoFieldContainer (void)
virtual ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
SoBase (void)
virtual ~SoBase ()
virtual void destroy (void)
SbBool hasMultipleWriteRefs (void) const
SbBool writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void writeFooter (SoOutput *out) const
virtual const char * getFileFormatName (void) const

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVRMLGroup
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVRMLParent
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** getFieldDataPtr (void)
static void setNextActionMethodIndex (int index)
static int getNextActionMethodIndex (void)
static void incNextActionMethodIndex (void)
static void setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t getCurrentWriteCounter (void)
static void staticDataLock (void)
static void staticDataUnlock (void)

  Additional Inherited Members
Public Types inherited from SoVRMLGroup
enum CacheEnabled { OFF, ON, AUTO }
Public Types inherited from SoNode
enum NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000, COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoVRMLParent
SoMFNode addChildren
SoMFNode removeChildren
Protected Attributes inherited from SoGroup
SoChildList * children
Protected Attributes inherited from SoNode
SbUniqueId uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool isBuiltIn
Static Protected Attributes inherited from SoVRMLGroup
static int numRenderCaches = 2
Static Protected Attributes inherited from SoNode
static SbUniqueId nextUniqueId = 1
static int nextActionMethodIndex = 0

Detailed Description

The SoVRMLCollision class is used for collision detection with the avatar. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

Collision {
  eventIn      MFNode   addChildren
  eventIn      MFNode   removeChildren
  exposedField MFNode   children        []
  exposedField SFBool   collide         TRUE
  field        SFVec3f  bboxCenter      0 0 0      # (-,)
  field        SFVec3f  bboxSize        -1 -1 -1   # (0,) or -1,-1,-1
  field        SFNode   proxy           NULL
  eventOut     SFTime   collideTime
}

The Collision node is a grouping node that specifies the collision detection properties for its children (and their descendants), specifies surrogate objects that replace its children during collision detection, and sends events signalling that a collision has occurred between the avatar and the Collision node's geometry or surrogate. By default, all geometric nodes in the scene are collidable with the viewer except IndexedLineSet, PointSet, and Text. Browsers shall detect geometric collisions between the avatar (see SoVRMLNavigationInfo) and the scene's geometry and prevent the avatar from 'entering' the geometry. See 4.13.4, Collision detection and terrain following (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.13.4), for general information on collision detection.

If there are no Collision nodes specified in a VRML file, browsers shall detect collisions between the avatar and all objects during navigation.

Subclause 4.6.5, Grouping and children nodes (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.5), contains a description of the children, addChildren, and removeChildren fields and eventIns.

The Collision node's collide field enables and disables collision detection. If collide is set to FALSE, the children and all descendants of the Collision node shall not be checked for collision, even though they are drawn. This includes any descendent Collision nodes that have collide set to TRUE (i.e., setting collide to FALSE turns collision off for every node below it).

Collision nodes with the collide field set to TRUE detect the nearest collision with their descendent geometry (or proxies). When the nearest collision is detected, the collided Collision node sends the time of the collision through its collideTime eventOut. If a Collision node contains a child, descendant, or proxy (see below) that is a Collision node, and both Collision nodes detect that a collision has occurred, both send a collideTime event at the same time. A collideTime event shall be generated if the avatar is colliding with collidable geometry when the Collision node is read from a VRML file or inserted into the transformation hierarchy.

The bboxCenter and bboxSize fields specify a bounding box that encloses the Collision node's children. This is a hint that may be used for optimization purposes. The results are undefined if the specified bounding box is smaller than the actual bounding box of the children at any time. A default bboxSize value, (-1, -1, -1), implies that the bounding box is not specified and if needed shall be calculated by the browser. More details on the bboxCenter and bboxSize fields can be found in 4.6.4, Bounding boxes. (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.4),

The collision proxy, defined in the proxy field, is any legal children node as described in 4.6.5, Grouping and children nodes, (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.5), that is used as a substitute for the Collision node's children during collision detection. The proxy is used strictly for collision detection; it is not drawn. If the value of the collide field is TRUE and the proxy field is non-NULL, the proxy field defines the scene on which collision detection is performed. If the proxy value is NULL, collision detection is performed against the children of the Collision node. If proxy is specified, any descendent children of the Collision node are ignored during collision detection. If children is empty, collide is TRUE, and proxy is specified, collision detection is performed against the proxy but nothing is displayed. In this manner, invisible collision objects may be supported.

The collideTime eventOut generates an event specifying the time when the avatar (see SoVRMLNavigationInfo) makes contact with the collidable children or proxy of the Collision node. An ideal implementation computes the exact time of collision. Implementations may approximate the ideal by sampling the positions of collidable objects and the user. The SoVRMLNavigationInfo node contains additional information for parameters that control the avatar size.

Constructor & Destructor Documentation

  SoVRMLCollision::SoVRMLCollision (void )
Constructor.

  SoVRMLCollision::SoVRMLCollision (int numchildren)
Constructor. numchildren is the expected number of children.

  SoVRMLCollision::~SoVRMLCollision () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLCollision::getClassTypeId (void ) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLCollision::getTypeId (void ) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoVRMLGroup.

  const SoFieldData ** SoVRMLCollision::getFieldDataPtr (void ) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLCollision::getFieldData (void ) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoVRMLGroup.

  void SoVRMLCollision::initClass (void ) [static]

  void SoVRMLCollision::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoVRMLGroup.

  void SoVRMLCollision::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoVRMLGroup.

Member Data Documentation

  SoSFBool SoVRMLCollision::collide
Enable/disable collision.

  SoSFNode SoVRMLCollision::proxy
Proxy node(s) used for collision testing.

  SoSFTime SoVRMLCollision::collideTime
An eventOut sent for each collision that occurs.

Author

Generated automatically by Doxygen for Coin from the source code.